/*
    Mini-editor  - GuppY PHP Script - version 4.5
    CeCILL Copyright (C) 2004-2005 by Laurent Duveau
    Initiated by Laurent Duveau and Nicolas Alvs,
    followed by Albert Aymard, Jean Michel Misrachi and all the Team
      Web site = http://www.freeguppy.org/
      e-mail   = info@aldweb.com
	  
---------------------------------------------------------------	  
    KOIVI TTW WYSIWYG Editor Copyright (C) 2004 Justin Koivisto
    Version 2.0   LGPL - Copyright protected 
    Last Modified: 12/9/2004    

       Justin Koivisto
       justin.koivisto@gmail.com
       http://www.koivi.com 
---------------------------------------------------------------
	  
    Version History :
      v4.0 (06 December 2004)  : initial release, thanks Justin,
	                               TTW WYSIWYG Editor modified for Guppy adaptation (by Icare)
	                               added quotation functionnality (by Icare)
	    v4.5 (04 April 2005)     : optimized forbidden tags management in processInfo(),
	                               added code and preview functionnality (by Icare)
*/

function Display(hidden_field,path,baseurl,fwidth,fheight,content) {
    hidden_name=hidden_field;
    viewMode=1;
    wysiwyg_path=path;
    img_path='src="'+baseurl;
	frame_width=fwidth;
    frame_height=fheight;
    if( (browser.isWin32 && (browser.isGecko || browser.isIE5up))
            || ((browser.isMac || browser.isLinux || browser.isUnix) && browser.isGecko)) {
        DisplayEditor();
        LoadExistingContent(content);
        document.getElementById('wysiwyg_content').contentWindow.document.designMode='On';
        document.getElementById('wysiwyg_content').contentWindow.document.open();
        document.getElementById('wysiwyg_content').contentWindow.document.write(content);
        document.getElementById('wysiwyg_content').contentWindow.document.close();
	}
	else {
        ta_rows=Math.round(fheight/15);
        ta_cols=Math.round(fwidth/8);
        DisplayTextArea();
        LoadExistingContent(content);
    }
}

function DoTextFormat(command, optn) {
    if((command=='forecolor') || (command=='hilitecolor')) {
        if(browser.isIE5up) {
            SetColorIE(command);
	    }
	    else {
            parent.command=command;
            layerid=command+'0';
            buttonElement=document.getElementById(command);
            document.getElementById(layerid).style.left=GetOffsetLeft(buttonElement) + 'px';
            document.getElementById(layerid).style.top=(GetOffsetTop(buttonElement) + buttonElement.offsetHeight) + 'px';
            if(document.getElementById(layerid).style.visibility=='hidden')
                document.getElementById(layerid).style.visibility='visible';
            else {
                document.getElementById(layerid).style.visibility='hidden';
            }
            var sel=document.getElementById('wysiwyg_content').contentWindow.document.selection;
            if(sel!=null) {
                rng=sel.createRange();
            }
        }
    } else if(command=='createlink') {
        var szURL=prompt('Enter a URL:', '');

        if(document.getElementById('wysiwyg_content').contentWindow.document.queryCommandEnabled(command)) {
            document.getElementById('wysiwyg_content').contentWindow.document.execCommand('CreateLink',false,szURL);
            return true;
        } else return false;
	}
	else {
        if(document.getElementById('wysiwyg_content').contentWindow.document.queryCommandEnabled(command)) {
              document.getElementById('wysiwyg_content').contentWindow.document.execCommand(command, false, optn);
              return true;
          } else return false;
    }
    document.getElementById('wysiwyg_content').contentWindow.focus();
}

function SetColor(color) {
    elem=command+'0';
    document.getElementById('wysiwyg_content').contentWindow.focus();
    if(document.getElementById('wysiwyg_content').contentWindow.document.queryCommandEnabled(command)) {
        document.getElementById('wysiwyg_content').contentWindow.document.execCommand(command, false, color);
    } else return false;
    document.getElementById('wysiwyg_content').contentWindow.focus();
    document.getElementById(elem).style.visibility='hidden';
    return true;
}

function SetColorIE(command,args) {
    elem=command+'0';
    buttonElement=document.getElementById(elem);
    var color = showModalDialog(wysiwyg_path+'/palette-ie.html', 0, 'resizable: no; help: no; status: no; scroll: no;');
     if(command=='hilitecolor') command='backcolor';
    if(document.getElementById('wysiwyg_content').contentWindow.document.queryCommandEnabled(command)) {
        document.getElementById('wysiwyg_content').contentWindow.document.execCommand(command, false, color);
    } else return false;
    document.getElementById('wysiwyg_content').contentWindow.focus();
    return true;
}

function GetOffsetTop(elm) {
    var mOffsetTop=elm.offsetTop;
    var mOffsetParent=elm.offsetParent;
    while(mOffsetParent) {
        mOffsetTop += mOffsetParent.offsetTop;
        mOffsetParent=mOffsetParent.offsetParent;
    }
    return mOffsetTop;
}

function GetOffsetLeft(elm) {
    var mOffsetLeft=elm.offsetLeft;
    var mOffsetParent=elm.offsetParent;
    while(mOffsetParent) {
        mOffsetLeft += mOffsetParent.offsetLeft;
        mOffsetParent=mOffsetParent.offsetParent;
    }
    return mOffsetLeft;
}

function ProcessInfo() {
    var htmlCode=document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML;
    htmlCode = htmlCode.replace(/\r\n/g,""); 
    htmlCode = htmlCode.replace(/\r/g,""); 
    htmlCode = htmlCode.replace(/\n/g,""); 
    htmlCode = htmlCode.replace(/\\/g,"&#92;");
    var sup_url = new RegExp(img_path,"ig") ;
    htmlCode = htmlCode.replace(sup_url, "src=\"");
    htmlCode = htmlCode.replace(/<img[^>]*src=[\"']?http:\/\/[^>]*>/ig, "<img src=\"inc/img/general/no_img.gif\" alt=\"Forbidden!\" />");
    htmlCode = htmlCode.replace(/<sup>/ig, "<br /><div><span style='padding: 2px; position:relative; top:4px; left:10px; background-color: #FEFEFE;'><i>Dixit...</i></span><div style='padding: 4px; background-color: #FEFEFE; border: 1px solid #000099'>");
    htmlCode = htmlCode.replace(/<\/sup>/ig, "</div></div><br />");
    htmlCode = htmlCode.replace(/<sub>/ig,"<br /><code>");
    htmlCode = htmlCode.replace(/<\/sub>/ig,"</code><br />");
    htmlCode = htmlCode.replace(/<a href=([^ |>]*)/gi, "<a href=$1 target=\"_blank\"");
    htmlCode = htmlCode.replace(/color=#([^ |>]*)/gi, "color=\"#$1\"");
    htmlCode = htmlCode.replace(/align=([^ |>]*)/gi, "align=\"$1\"");
    htmlCode = htmlCode.replace(/width=([^ |>]*)/ig, "wid&shy;th=$1");
    htmlCode = htmlCode.replace(/height=([^ |>]*)/ig, "heig&shy;ht=$1");
    htmlCode = htmlCode.replace(/width:([^ |>]*)/ig,"wid&shy;th:$1");
    htmlCode = htmlCode.replace(/height:([^ |>]*)/ig, "heig&shy;ht:$1");
    htmlCode = htmlCode.replace(/<t/ig, "<$shy;t");
    htmlCode = htmlCode.replace(/<\/t/ig, "<$shy;/t");
    htmlCode = htmlCode.replace(/<meta/ig, "<me&shy;ta");
    htmlCode = htmlCode.replace(/<script/ig, "<scri&shy;pt");
    htmlCode = htmlCode.replace(/javascript:/ig, "javascri&shy;pt:");
    htmlCode = htmlCode.replace(/ on[cm]/ig, " on-&shy;"); 
    htmlCode = htmlCode.replace(/{/ig, "&shy;{&shy;");
    htmlCode = htmlCode.replace(/<applet/ig, "<&shy;applet");
    htmlCode = htmlCode.replace(/<object/ig, "<&shy;object");
    htmlCode = htmlCode.replace(/<iframe/ig, "<&shy;iframe");
    htmlCode = htmlCode.replace(/<(php)?\?/ig, "<p&shy;hp?");
    htmlCode = htmlCode.replace(/<br>/gi,"<br />");
    htmlCode = htmlCode.replace(/<hr>/gi,"<hr />");
    document.getElementById('wysiwyg_hidden').value=htmlCode;
    return true;
}

function LoadExistingContent(content) {
    document.getElementById('wysiwyg_hidden').value=content;
}

function ToggleMode() {
    if(browser.isIE5up) {
        if(viewMode == 2) {
            document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML = document.getElementById('wysiwyg_content').contentWindow.document.body.innerText;
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontFamily = '';
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontSize = '';
            document.getElementById('wysiwyg_content').contentWindow.focus();
            viewMode = 1;
        }
	else {
            document.getElementById('wysiwyg_content').contentWindow.document.body.innerText = document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML;
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontFamily = 'monospace';
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontSize = '10pt';
            document.getElementById('wysiwyg_content').contentWindow.focus();
            viewMode = 2;
        }
	}
	else {
        if(viewMode == 2) {
            var html = document.getElementById('wysiwyg_content').contentWindow.document.body.ownerDocument.createRange();
            html.selectNodeContents(document.getElementById('wysiwyg_content').contentWindow.document.body);
            document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML = html.toString();
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontFamily = '';
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontSize = '';
            document.getElementById('toolbars').style.visibility='visible';
            viewMode = 1;
        }
	else {
            var html = document.createTextNode(document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML);
            document.getElementById('wysiwyg_content').contentWindow.document.body.innerHTML = '';
            document.getElementById('wysiwyg_content').contentWindow.document.body.appendChild(html);
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontFamily = 'monospace';
            document.getElementById('wysiwyg_content').contentWindow.document.body.style.fontSize = '10pt';
            document.getElementById('toolbars').style.visibility='hidden';
            viewMode = 2;
        }
    }
}

function insertNodeAtSelection(win, insertNode) {
    var sel = win.getSelection();
    var range = sel.getRangeAt(0); 
    sel.removeAllRanges();
    range.deleteContents();
    var container = range.startContainer;
    var pos = range.startOffset;
    range=document.createRange();

    if (container.nodeType==3 && insertNode.nodeType==3) {
        container.insertData(pos, insertNode.nodeValue);
        range.setEnd(container, pos+insertNode.length);
        range.setStart(container, pos+insertNode.length);
	}
	else {
        var afterNode;
        if (container.nodeType==3) {
          var textNode = container;
          container = textNode.parentNode;
          var text = textNode.nodeValue;

          var textBefore = text.substr(0,pos);
          var textAfter = text.substr(pos);

          var beforeNode = document.createTextNode(textBefore);
          var afterNode = document.createTextNode(textAfter);

          container.insertBefore(afterNode, textNode);
          container.insertBefore(insertNode, afterNode);
          container.insertBefore(beforeNode, insertNode);

          container.removeChild(textNode);
	}
	else {
          afterNode = container.childNodes[pos];
          container.insertBefore(insertNode, afterNode);
        }
    }
}

function DisplayTextArea() {
 document.write('<p style="background-color: yellow; color: red; padding: 3px;"><b>WARNING:</b> Your browser does not support the WYSIWYG editor. The script you are posting to may expect HTML code.</p>');
 document.write('<textarea name="'+hidden_name+'" id="wysiwyg_hidden" rows="'+ta_rows+'" cols="'+ta_cols+'"></textarea><br />');
}
